<?php

namespace Picea\Asset\Action;

use Picea\Asset\FileFetcher;
use Picea\EventTrait;

class Install {

    use EventTrait;

    public array $actions;

    public function __construct(
        InstallActionInterface $action, ... $actions
    ) {
        $this->actions = array_filter(array_merge([ $action ], $actions));
    }

    public function launch(FileFetcher $fileFetcher) : array
    {
        $output = [];

        foreach($this->actions as $action) {
            $output[$action::class] = $action->run();
        }

        return $output;
    }

}
