<?php

namespace Picea\Asset;

use Picea\Compiler;
use Picea\EventTrait;

class Asset {

    use EventTrait;

    public function __construct(
        public Config $config,
        public Action\Install $install,
        public FileFetcher $fileFetcher,
    ) { }

    public function registerExtension(Compiler $compiler) : self
    {
        $compiler->registerExtension(new Extension\ImportmapExtension());

        return $this;
    }

    public function launchInstall() : void
    {
        $result = $this->install->launch($this->fileFetcher);
    }

}
