<?php declare(strict_types=1);

namespace Picea\Asset;

use RecursiveIteratorIterator, RecursiveDirectoryIterator;

class FileFetcher extends \Picea\FileFetcher
{
    protected array $folderList = [];

    public array $supportedExtensionList = [];

    public function folderList(?array $set = null) : ?array
    {
        return $set === null ? $this->folderList : $this->folderList = $set;
    }

    public function getFileList() : array
    {
        usort($this->folderList, fn($a, $b) => $a['order'] <=> $b['order']);

        $list = [];

        foreach($this->folderList() as $folder) {
            $path = $folder['path'] . "/";
            $list[$path] = [];

            if ( \file_exists($path) ) {
                $iterator = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($path, RecursiveDirectoryIterator::SKIP_DOTS), RecursiveIteratorIterator::SELF_FIRST, RecursiveIteratorIterator::CATCH_GET_CHILD);

                foreach ($iterator as $file) {
                    if ( $file->isFile() ) {
                        $list[$path][] = $file;
                    }
                }
            }
        }

        return $list;
    }
}
